<%-- 
    Document   : drag_schedule_tools
    Created on : Jun 22, 2010, 2:33:52 PM
    Author     : hkzhou
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Session Schedule Tool</title>
        <script type="text/javascript" src="js/jquery-1.4.2.js"></script>
        <script type="text/javascript" src="js/jquery.ui.core.js"></script>
        <script type="text/javascript" src="js/jquery.ui.widget.js"></script>
        <script type="text/javascript" src="js/jquery.ui.mouse.js"></script>
        <script type="text/javascript" src="js/jquery.ui.position.js"></script>
        <script type="text/javascript" src="js/jquery.ui.draggable.js"></script>
        <script type="text/javascript" src="js/jquery.ui.droppable.js"></script>
        <script type="text/javascript" src="js/jquery.ui.datepicker.js"></script>
        <script type="text/javascript" src="js/jquery.ui.slider.js"></script>
        <script type="text/javascript" src="js/jquery.effects.core.js"></script>
        <script type="text/javascript" src="js/jquery.effects.slide.js"></script>
        <link rel="stylesheet" href="css/jquery.ui.core.css" type="text/css" media="screen"/>
        <link rel="stylesheet" href="css/jquery.ui.theme.css" type="text/css" media="screen"/>
        <link rel="stylesheet" href="css/jquery.ui.slider.css" type="text/css" media="screen"/>
        <style type="text/css">
            div { -moz-user-select:none; -webkit-user-select: none;}
            #demo-frame > div.demo { padding: 10px !important; }
            .scroll-pane { overflow: auto; width: 960px; float: left;border-width: 1px 0px 1px 0px;border-color: gray}
            .scroll-content { width: 2440px; float: left; }
            .scroll-content-item { width: 100px; height: 100px; float: left; margin: 10px; font-size: 3em; line-height: 96px; text-align: center; }
            * html .scroll-content-item { display: inline; } /* IE6 float double margin bug */
            .scroll-bar-wrap { clear: left; padding: 0 4px 0 2px; margin: 0 -1px -1px -1px; }
            .scroll-bar-wrap .ui-slider { background: none; border:0; height: 2em; margin: 0 auto;  }
            .scroll-bar-wrap .ui-handle-helper-parent { position: relative; width: 100%; height: 100%; margin: 0 auto; }
            .scroll-bar-wrap .ui-slider-handle { top:.2em; height: 1.5em; }
            .scroll-bar-wrap .ui-slider-handle .ui-icon { margin: -8px auto 0; position: relative; top: 50%; }
        </style>
    </head>
    <body>
        <div class="demo">
            <div id="calendar-content" style="height: 510px">
                <jsp:include page="four_day_view.jsp"/>
            </div>
            <div id="session-handler" style="height:149px;width: 22px;float: left;position: relative;border-width: 1px 0px 1px 1px;
                 border-color: gray;border-style: solid;background: url(images/session-fold.PNG) 0 0 no-repeat" onclick="toggleSessionDock()"></div>
            <div id="session-container" class="scroll-pane ui-widget ui-widget-header">
                <div class="scroll-content">
                    <div class="scroll-content-item ui-widget-header">1</div>
                    <div class="scroll-content-item ui-widget-header">2</div>
                    <div class="scroll-content-item ui-widget-header">3</div>
                    <div class="scroll-content-item ui-widget-header">4</div>
                    <div class="scroll-content-item ui-widget-header">5</div>
                    <div class="scroll-content-item ui-widget-header">6</div>
                    <div class="scroll-content-item ui-widget-header">7</div>
                    <div class="scroll-content-item ui-widget-header">8</div>
                    <div class="scroll-content-item ui-widget-header">9</div>
                    <div class="scroll-content-item ui-widget-header">10</div>
                    <div class="scroll-content-item ui-widget-header">11</div>
                    <div class="scroll-content-item ui-widget-header">12</div>
                    <div class="scroll-content-item ui-widget-header">13</div>
                    <div class="scroll-content-item ui-widget-header">14</div>
                    <div class="scroll-content-item ui-widget-header">15</div>
                    <div class="scroll-content-item ui-widget-header">16</div>
                    <div class="scroll-content-item ui-widget-header">17</div>
                    <div class="scroll-content-item ui-widget-header">18</div>
                    <div class="scroll-content-item ui-widget-header">19</div>
                    <div class="scroll-content-item ui-widget-header">20</div>
                </div>
                <div class="scroll-bar-wrap ui-widget-content ui-corner-bottom">
                    <div class="scroll-bar"></div>
                </div>
            </div>
            <div style="height:149px;width: 22px;float: left;border-width: 1px 0px 1px 1px;border-color: gray;border-style: solid" onclick="toggleSessionDock()">w</div>
            <div id="construct-session-content" style="height: 149px;width: 970px;display: none;float: left;border: 1px solid gray">
                hello world
            </div>
        </div><!-- End demo -->
    </body>
</html>

<script type="text/javascript">
    $(document).ready(function(){
        $(".scroll-content-item").draggable({ helper: 'clone',
            cursorAt: { cursor:'auto' ,top: 56, left: 56 }, containment: '#day_request', opacity: 0.85});
        //scrollpane parts
        var scrollPane = $('.scroll-pane');
        var scrollContent = $('.scroll-content');

        //build slider
        var scrollbar = $(".scroll-bar").slider({
            slide:function(e, ui){
                if( scrollContent.width() > scrollPane.width() ){ scrollContent.css('margin-left', Math.round( ui.value / 100 * ( scrollPane.width() - scrollContent.width() )) + 'px'); }
                else { scrollContent.css('margin-left', 0); }
            }
        });

        //append icon to handle
        var handleHelper = scrollbar.find('.ui-slider-handle')
        .mousedown(function(){
            scrollbar.width( handleHelper.width() );
        })
        .mouseup(function(){
            scrollbar.width( '100%' );
        })
        .append('<span class="ui-icon ui-icon-grip-dotted-vertical"></span>')
        .wrap('<div class="ui-handle-helper-parent"></div>').parent();

        //change overflow to hidden now that slider handles the scrolling
        scrollPane.css('overflow','hidden');

        $(".scroll-content-item").draggable({helper: 'clone',cursor: 'crosshair'});

        //size scrollbar and handle proportionally to scroll distance
        function sizeScrollbar(){
            var remainder = scrollContent.width() - scrollPane.width();
            var proportion = remainder / scrollContent.width();
            var handleSize = scrollPane.width() - (proportion * scrollPane.width());
            scrollbar.find('.ui-slider-handle').css({
                width: handleSize,
                'margin-left': -handleSize/2
            });
            handleHelper.width('').width( scrollbar.width() - handleSize);
        }

        //reset slider value based on scroll content position
        function resetValue(){
            var remainder = scrollPane.width() - scrollContent.width();
            var leftVal = scrollContent.css('margin-left') == 'auto' ? 0 : parseInt(scrollContent.css('margin-left'));
            var percentage = Math.round(leftVal / remainder * 100);
            scrollbar.slider("value", percentage);
        }
        //if the slider is 100% and window gets larger, reveal content
        function reflowContent(){
            var showing = scrollContent.width() + parseInt( scrollContent.css('margin-left') );
            var gap = scrollPane.width() - showing;
            if(gap > 0){
                scrollContent.css('margin-left', parseInt( scrollContent.css('margin-left') ) + gap);
            }
        }

        //change handle position on window resize
        $(window).resize(function(){
            resetValue();
            sizeScrollbar();
            reflowContent();
        });
        //init scrollbar size
        setTimeout(sizeScrollbar,10);//safari wants a timeout
    });
    function toggleSessionDock(){
        var changed = false;
        if($("#construct-session-content").css("display")=="block"){
            $("#session-handler").css("background","url(images/session-fold.PNG) 0 0 no-repeat");
            $("#construct-session-content").hide();
            changed = true;
        }
        $("#session-container").toggle("slide",{direction:"left"},200,function(){
            if($("#construct-session-content").css("display")=="none"&&!changed){
                $("#session-handler").css("background","url(images/session-unfold.PNG) 0 0 no-repeat");
                $("#construct-session-content").show();
            }
        });
        
    }
</script>
