<link rel="stylesheet" href="css/day.css" type="text/css" media="screen"/>
<link rel="stylesheet" href="css/jquery.ui.datepicker.css" type="text/css" media="screen"/>
<div id="calendar-title" style="height: 30px">
    <table width="1002px" cellpadding="0" cellspacing="1" border="0" bgcolor="#e8eef7" style="height: 100%">
        <tbody>
            <tr align="center">
                <td width="38px" style="border:1px; border-color: #ddd; border-style: solid">
                    <input id="select_date" type="hidden" value=""/>
                </td>
                <td id="day0" style="border: 1px solid #ddd;background: url(images/prev_month.gif) left center no-repeat" onclick="changeDate(-4)">2010-06-22</td>
                <td id="day1" style="border: 1px solid #ddd">2010-06-23</td>
                <td id="day2" style="border: 1px solid #ddd">2010-06-24</td>
                <td id="day3" style="border: 1px solid #ddd;background: url(images/next_month.gif) right center no-repeat" onclick="changeDate(4)">2010-06-25</td>
            </tr>
        </tbody>
    </table>
</div>
<div id="day_request" style="height:480px;overflow:auto;position:relative">
    <table id="calendar_table" class="calender-events" style="height:1008px;width:1000px" cellpadding="0" cellspacing="0">
        <tbody>
            <tr>
                <td style="width: 40px;"></td>
                <td colspan="4">
                    <div class="calendar-wrapper">
                        <div class="hour-markers" style="font-size: 20px;">
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                            <div class="dual-marker"></div>
                        </div>
                    </div>
                </td>
            </tr>
            <tr>
                <td class="calendar-times" style="width: 40px;">
                    <div class="day-time" style="height: 41px;">12am</div>
                    <div class="day-time" style="height: 41px;">1am</div>
                    <div class="day-time" style="height: 41px;">2am</div>
                    <div class="day-time" style="height: 41px;">3am</div>
                    <div class="day-time" style="height: 41px;">4am</div>
                    <div class="day-time" style="height: 41px;">5am</div>
                    <div class="day-time" style="height: 41px;">6am</div>
                    <div class="day-time" style="height: 41px;">7am</div>
                    <div class="day-time" style="height: 41px;">8am</div>
                    <div class="day-time" style="height: 41px;">9am</div>
                    <div class="day-time" style="height: 41px;">10am</div>
                    <div class="day-time" style="height: 41px;">11am</div>
                    <div class="day-time" style="height: 41px;">12pm</div>
                    <div class="day-time" style="height: 41px;">1pm</div>
                    <div class="day-time" style="height: 41px;">2pm</div>
                    <div class="day-time" style="height: 41px;">3pm</div>
                    <div class="day-time" style="height: 41px;">4pm</div>
                    <div class="day-time" style="height: 41px;">5pm</div>
                    <div class="day-time" style="height: 41px;">6pm</div>
                    <div class="day-time" style="height: 41px;">7pm</div>
                    <div class="day-time" style="height: 41px;">8pm</div>
                    <div class="day-time" style="height: 41px;">9pm</div>
                    <div class="day-time" style="height: 41px;">10pm</div>
                    <div class="day-time" style="height: 41px;">11pm</div>
                </td>
                <td class="calendar-col">
                    <div id="dayCol0" class="eventwrapper" style="height: 1008px; margin-bottom: -1008px;"></div>
                    <div class="overlaywrapper" id="dayOver0"></div>
                </td>
                <td class="calendar-col">
                    <div id="dayCol1" class="eventwrapper" style="height: 1008px; margin-bottom: -1008px;"></div>
                    <div class="overlaywrapper" id="dayOver1"></div>
                </td>
                <td class="calendar-col">
                    <div id="dayCol2" class="eventwrapper" style="height: 1008px; margin-bottom: -1008px;"></div>
                    <div class="overlaywrapper" id="dayOver2"></div>
                </td>
                <td class="calendar-col">
                    <div id="dayCol3" class="eventwrapper" style="height: 1008px; margin-bottom: -1008px;"></div>
                    <div class="overlaywrapper" id="dayOver3"></div>
                </td>
            </tr>
        </tbody>
    </table>
</div>
<script type="text/javascript">
    $(document).ready(function(){
        $(".eventwrapper").droppable({
            accept:".scroll-content-item",
            drop: function(event, ui) {
                addEvent(event);
                //adjustOverlapItems(event);
            }
        });
        $("#day_request").attr("scrollTop",318);
        $("#select_date").val($.datepicker.formatDate("yy-mm-dd", new Date()), null);
        changeCalendarShow();
        $("#select_date").datepicker({
            dateFormat: "yy-mm-dd",
            showOn: 'button',
            buttonImage: 'images/calendar.png',
            buttonImageOnly: true,
            onSelect: function(selectedDate) {
                changeCalendarShow();
            }
        });
        
    });

    function changeDate(day){
        var select_day = new Date($("#select_date").val());
        $("#select_date").val($.datepicker.formatDate("yy-mm-dd",new Date(select_day.setDate(select_day.getDate()+day)),null));
        changeCalendarShow();
    }

    function changeCalendarShow(){
        $("#today_div").remove();
        $("#nowmarker").remove();
        var date = $("#select_date").val();
        for(var i=0;i<4;i++){
            var select_day = new Date(date);
            var day_str = $.datepicker.formatDate("yy-mm-dd",new Date(select_day.setDate(select_day.getDate()+i)));
            $("#day"+i).html(day_str);
            if(day_str==$.datepicker.formatDate("yy-mm-dd",new Date())){
                $("#dayCol"+i).before("<div id=\"today_div\" class=\"calendar-today\" style=\"height: 1008px; margin-bottom: -1008px;\">&nbsp;</div>");
                $("#dayOver"+i).html("<div class='nowmarker' id='nowmarker' style='top: 0px;z-index:1000'></div>");
                var d = new Date();
                var hours = d.getHours();
                var minutes = d.getMinutes();
                var top = hours*42+Math.ceil(minutes/60*42);
                $("#nowmarker").css('top',top);
            }
        }
        
    }

    var startPoint;
    var i = 0;
    var time_array = new Array("0:00am","0:30am","1:00am","1:30am","2:00am","2:30am","3:00am","3:30am",
    "4:00am","4:30am","5:00am","5:30am","6:00am","6:30am","7:00am","7:30am",
    "8:00am","8:30am","9:00am","9:30am","10:00am","10:30am","11:00am","11:30am",
    "12:00pm","12:30pm","1:00pm","1:30pm","2:00pm","2:30pm",
    "3:00pm","3:30pm","4:00pm","4:30pm","5:00pm","5:30pm","6:00pm","6:30pm",
    "7:00pm","7:30pm","8:00pm","8:30pm","9:00pm","9:30pm",
    "10:00pm","10:30pm","11:00pm","11:30pm");

    var addEvent = function(e){
        startPoint = e.pageY;

        var top = e.pageY + $("#day_request").attr("scrollTop") - $("#day_request").attr("offsetTop");
        top = Math.floor(top/21)*21;

        var leftid = Math.floor((e.pageX - 40)/237);

        var same_block_items = new Array();

        $("#dayCol"+leftid).find(".event-item-div").each(function(){
            var block_start = $(this).position().top;
            var block_end = block_start + $(this).height();
            if(top>=block_start&&top<block_end-1){
                same_block_items.push($(this).attr("id"));
            }
        });

        var width = 235;
        var left = 0;
        if(same_block_items.length>0){
            width = Math.ceil(235/(same_block_items.length+1));
            left = same_block_items.length * width;
        }
        for(var j=0;j<same_block_items.length;j++){
            $("#"+same_block_items[j]).css("width", width);
            $("#"+same_block_items[j]).css("left", width*j);
        }

        i++;
        $("#dayCol"+leftid).append("<div id='event_"+i+"' style='top: "+top+"px; left: "+left+"px; width: "+width+"px;' class='event-item-div'>"
            +"<dl style='border-color: rgb(41, 82, 163); height: 0px; background-color: rgb(102, 140, 217);' class='event-item'>"
            +"<dt style='background-color: rgb(41, 82, 163);'></dt>"
            +"<dd><span></span></dd>"
            +"</dl></div>");
        $("#dayCol"+leftid).bind("mousemove", function(e){
            var height;
            var start_time;
            var end_time;
            if(e.pageY-startPoint<0){
                var newtop = e.pageY + $("#day_request").attr("scrollTop") - $("#day_request").attr("offsetTop");
                newtop = Math.floor(newtop/21)*21;
                $("#event_"+i).css("top",newtop);
                height = (Math.ceil((top-newtop)/21)+1)*21;
                start_time = time_array[Math.floor(newtop/21)];
                end_time = time_array[Math.floor(top/21)+1];
            }else{
                $("#event_"+i).css("top",top);
                height = Math.ceil((e.pageY-startPoint)/21)*21;
                start_time = time_array[Math.floor(top/21)];
                end_time = time_array[Math.floor(top/21)+Math.ceil((e.pageY-startPoint)/21)];
            }
            $("#event_"+i).find("dt").html(
            "<div style=\"float:left;\">"+start_time+"-"+end_time+"</div>"
                +"<div style=\"float:right;padding-right:1px;\"><img src=\"images/cross_white.png\" style=\"cursor:pointer\" onclick=\"delItem("+i+")\"/></div><div style=\"clear:both\" />");
            $("#event_"+i).find("dl").css("height",(height-2)+"px");
        });
        $("#dayCol"+leftid).bind("mouseup", function(e){
            var def_end_time = time_array[Math.floor(top/21)+Math.ceil((e.pageY-startPoint)/21)];
            if($("#event_"+i).find("dl").css("height")=="0px"){
                $("#event_"+i).find("dl").css("height","42px");
                def_end_time = time_array[Math.floor(top/21)+2];
                $("#event_"+i).find("dt").html("<div style=\"float:left\">"+time_array[Math.floor(top/21)]+"-"+time_array[Math.floor(top/21)+2]+"</div>"
                    +"<div style=\"float:right;padding-right:1px;\">"
                    +"<img src=\"images/cross_white.png\" style=\"cursor:pointer\" onclick=\"delItem("+i+")\"/></div><div style=\"clear:both\" />");
            }
            $("#dayCol"+leftid).unbind("mousemove");
            //showAddRequestByTime(time_array[Math.floor(top/21)],def_end_time);
        });
        $(".event-item-div").draggable({
            grid: [0,21],
            drag: function() {
                var item_top = $(this).position().top;
                var item_height = $(this).find("dl").height();
                var item_id = $(this).attr("id");
                item_id = item_id.substr(item_id.indexOf("_")+1,item_id.length);
                $(this).find("dt").html("<div style=\"float:left\">"+time_array[Math.floor(item_top/21)]+"-"+time_array[Math.floor(item_top/21)+Math.floor(item_height/21)+1]+"</div>"
                    +"<div style=\"float:right;padding-right:1px;\">"
                    +"<img src=\"images/cross_white.png\" style=\"cursor:pointer\" onclick=\"delItem("+item_id+")\"/></div><div style=\"clear:both\" />");
            }
        });
    };

    function delItem(i){
        $("#event_"+i).remove();
    }

    //$("#eventwrapper").bind("mousedown", addEvent);

    $(".event-item-div").bind("mousedown",function(e){
        $(".event-item-div").css("z-index",0);
        $(this).css("z-index",999);
        return false;
    });
    $(".event-item-div").bind("mousemove",function(e){
        return false;
    });
    $(".event-item-div").bind("mouseup",function(e){
        return false;
    });
</script>
